diff --git a/math/test-tgmath2.c b/math/test-tgmath2.c
index b376fd6..4d828fe 100644
--- a/math/test-tgmath2.c
+++ b/math/test-tgmath2.c
@@ -89,12 +89,6 @@ enum
Â int count;
Â int counts[Tlast][C_last];
Â 
-int
-test (const int Vint4, const long long int Vllong4)
-{
-Â Â int result = 0;
-Â Â int quo = 0;
-
Â #define FAIL(str) \
Â Â Â do								\
Â Â Â Â Â {								\
@@ -138,6 +132,11 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â while (0)
Â #define TEST(expr, type, fn) TEST2(expr, type, type, fn)
Â 
+int
+test_cos (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â TEST (cos (vfloat1), float, cos);
Â Â Â TEST (cos (vdouble1), double, cos);
Â Â Â TEST (cos (vldouble1), ldouble, cos);
@@ -155,6 +154,14 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST (cos (Vcdouble1), cdouble, cos);
Â Â Â TEST (cos (Vcldouble1), cldouble, cos);
Â 
+Â Â return result;
+}
+
+int
+test_fabs (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â TEST (fabs (vfloat1), float, fabs);
Â Â Â TEST (fabs (vdouble1), double, fabs);
Â Â Â TEST (fabs (vldouble1), ldouble, fabs);
@@ -180,6 +187,13 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST (fabs (Vcdouble1), double, cabs);
Â Â Â TEST (fabs (Vcldouble1), ldouble, cabs);
Â 
+Â Â return result;
+}
+
+int
+test_conj (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
Â Â Â TEST (conj (vfloat1), cfloat, conj);
Â Â Â TEST (conj (vdouble1), cdouble, conj);
Â Â Â TEST (conj (vldouble1), cldouble, conj);
@@ -197,6 +211,14 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST (conj (Vcdouble1), cdouble, conj);
Â Â Â TEST (conj (Vcldouble1), cldouble, conj);
Â 
+Â Â return result;
+}
+
+int
+test_expm1 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â TEST (expm1 (vfloat1), float, expm1);
Â Â Â TEST (expm1 (vdouble1), double, expm1);
Â Â Â TEST (expm1 (vldouble1), ldouble, expm1);
@@ -208,6 +230,13 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST (expm1 (Vint1), double, expm1);
Â Â Â TEST (expm1 (Vllong1), double, expm1);
Â 
+Â Â return result;
+}
+
+int
+test_lrint (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
Â Â Â TEST2 (lrint (vfloat1), float, long int, lrint);
Â Â Â TEST2 (lrint (vdouble1), double, long int, lrint);
Â Â Â TEST2 (lrint (vldouble1), ldouble, long int, lrint);
@@ -219,6 +248,14 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST2 (lrint (Vint1), double, long int, lrint);
Â Â Â TEST2 (lrint (Vllong1), double, long int, lrint);
Â 
+Â Â return result;
+}
+
+int
+test_ldexp (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â TEST (ldexp (vfloat1, 6), float, ldexp);
Â Â Â TEST (ldexp (vdouble1, 6), double, ldexp);
Â Â Â TEST (ldexp (vldouble1, 6), ldouble, ldexp);
@@ -230,6 +267,9 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â TEST (ldexp (Vint1, 6), double, ldexp);
Â Â Â TEST (ldexp (Vllong1, 6), double, ldexp);
Â 
+Â Â return result;
+}
+
Â #define FIRST(x, y) (y, x)
Â #define SECOND(x, y) (x, y)
Â #define NON_LDBL_TEST(fn, argm, arg, type, fnt) \
@@ -307,25 +347,82 @@ test (const int Vint4, const long long int Vllong4)
Â Â Â NON_LDBL_CTEST (fn, FIRST, Vcdouble2, cdouble, fnt); \
Â Â Â NON_LDBL_CTEST (fn, SECOND, Vcdouble2, cdouble, fnt);
Â 
+int
+test_atan2 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â BINARY_TEST (atan2, atan2);
Â 
+Â Â return result;
+}
+
+int
+test_remquo (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+Â Â int quo = 0;
+
Â #define my_remquo(x, y) remquo (x, y, &quo)
Â Â Â BINARY_TEST (my_remquo, remquo);
Â #undef my_remquo
Â 
+Â Â return result;
+}
+
+int
+test_pow (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â Â Â BINARY_CTEST (pow, pow);
Â 
-Â Â /* Testing all arguments of fma would be just too expensive,
-Â Â Â Â Â so test just some.Â Â */
+Â Â return result;
+}
+
+/* Testing all arguments of fma would be just too expensive,
+Â Â Â so test just some.Â Â */
+
+int
+test_fma_1 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â #define my_fma(x, y) fma (x, y, vfloat3)
Â Â Â BINARY_TEST (my_fma, fma);
Â #undef my_fma
+
+Â Â return result;
+}
+
+int
+test_fma_2 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â #define my_fma(x, y) fma (x, vfloat3, y)
Â Â Â BINARY_TEST (my_fma, fma);
Â #undef my_fma
+
+Â Â return result;
+}
+
+int
+test_fma_3 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
+
Â #define my_fma(x, y) fma (Vfloat3, x, y)
Â Â Â BINARY_TEST (my_fma, fma);
Â #undef my_fma
+
+Â Â return result;
+}
+
+int
+test_fma_4 (const int Vint4, const long long int Vllong4)
+{
+Â Â int result = 0;
Â Â Â TEST (fma (vdouble1, Vdouble2, vllong3), double, fma);
Â Â Â TEST (fma (vint1, Vint2, vint3), double, fma);
Â Â Â TEST (fma (Vldouble1, vldouble2, Vldouble3), ldouble, fma);
@@ -337,7 +434,19 @@ test (const int Vint4, const long long int Vllong4)
Â static int
Â do_test (void)
Â {
-Â Â return test (vint1, vllong1);
+Â Â return test_cos (vint1, vllong1)
+	Â + test_fabs (vint1, vllong1)
+	Â + test_conj (vint1, vllong1)
+	Â + test_expm1 (vint1, vllong1)
+	Â + test_lrint (vint1, vllong1)
+	Â + test_ldexp (vint1, vllong1)
+	Â + test_atan2 (vint1, vllong1)
+	Â + test_remquo (vint1, vllong1)
+	Â + test_pow (vint1, vllong1)
+	Â + test_fma_1 (vint1, vllong1)
+	Â + test_fma_2 (vint1, vllong1)
+	Â + test_fma_3 (vint1, vllong1)
+	Â + test_fma_4 (vint1, vllong1);
Â }
Â 
Â /* Now generate the three functions.Â Â */